#include<stdio.h>

int main(){

  int n;

  double factorial(int);

  
  for(n=0;n<31;n++){

    printf("n = %d, n! = %f\n", n, factorial(n)); 
        
  }

  return 0;
  
} 


/* 階乗を計算して倍精度実数を返す関数、引数は整数型のn*/
double factorial(int n){
    
  int k;
  double fact; 

  fact = 0.0;
  if(n<0) return(fact); 
  
  fact = 1.0; // 初期値1をセット
  if(n==0) return(fact); // n=0の場合は0!=1なので1を返して関数を終了

  /* 階乗n! を n * (n-1)!として計算。 (n-1)!の計算のためにfactorial()を再帰的に呼び出す */
  fact = factorial(n-1)*n; 
      
  return(fact); 

}
